<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml" xmlns:gri="http://java.sun.com/jsf/composite/gri">
    <a4j:region>
        <div class="form-horizontal">
            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                <ui:define name="label">#{messages['net.ihe.gazelle.hpd.OrganizationalUnit']}</ui:define>
                <ui:param name="id" value="nodeIn"/>
                <h:selectOneMenu value="#{currentRequest.selectedNode}" styleClass="form-control gzl-select-text"
                                 id="nodeIn">
                    <s:selectItems value="#{providerInformationSource.getAvailableNodes()}" var="n" label="#{n.name}"
                                   noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                    <a4j:ajax event="change" render="requestConfPanel" execute="@this"
                              listener="#{providerInformationSource.onNodeSelected(currentRequest)}"/>
                </h:selectOneMenu>
            </s:decorate>
            <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="dnToAd"
                        rendered="#{currentRequest.selectedNode != null}">
                <ui:param name="id" value="dnIn"/>
                <ui:define name="label">#{messages['net.ihe.gazelle.hpd.DNOfTheEntryToAdd']}</ui:define>
                <h:inputText id="dnIn" value="#{currentRequest.request.dn}" styleClass="form-control"/>
            </s:decorate>
        </div>
    </a4j:region>
    <s:div id="addDiv" rendered="#{currentRequest.selectedNode != null}">
        <h3>#{messages['net.ihe.gazelle.hpd.Attributes']}</h3>
        <gri:panel styleClass="panel-info">
            <f:facet name="header">New entry</f:facet>
            <div class="form-inline">
                <ui:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                    <ui:param name="id" value="attrName"/>
                    <ui:define name="label">Attribute's name</ui:define>
                    <rich:autocomplete mode="client"
                                       autocompleteList="#{currentReq.getAvailableAttributeTypes()}"
                                       value="#{currentRequest.dsmlAttr.name}" minChars="1" autofill="false"
                                       selectFirst="false"
                                       id="attrName" layout="list"/>
                </ui:decorate>
                <ui:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                    <ui:param name="id" value="attrValue"/>
                    <ui:define name="label">Value</ui:define>
                    <h:inputText value="#{currentRequest.value}" styleClass="form-control" id="attrValue"/>
                </ui:decorate>
                <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.AddAttribute']}" styleClass="gzl-btn-blue"
                                   actionListener="#{currentRequest.addAttributeToAddRequest()}"
                                   render="addDiv"/>
            </div>
        </gri:panel>
        <rich:dataTable value="#{currentRequest.request.attr}" var="at" id="attributeTable">
            <g:column>
                <ui:define name="header">#{messages['net.ihe.gazelle.hpd.AttributesName']}</ui:define>
                <h:outputText value="#{at.name}"/>
            </g:column>
            <g:column>
                <ui:define name="header">#{messages['net.ihe.gazelle.hpd.Values']})</ui:define>
                <a4j:repeat value="#{at.valuesForGui}" var="gval">
                    <div class="row">
                        <div class="col-md-8">
                            <h:inputText value="#{gval.guiValue}" size="90" styleClass="form-control"/>
                        </div>
                        <div class="col-md-2">
                            <a4j:commandLink
                                    actionListener="#{providerInformationSource.removeValueFromDsmlAttribute(at, gval)}"
                                    title="#{messages['net.ihe.gazelle.hpd.RemoveFromList']}" render="attributeTable">
                                <span class="gzl-icon-times"/>
                            </a4j:commandLink>
                        </div>
                    </div>
                </a4j:repeat>
            </g:column>
            <g:column>
                <ui:define name="header">#{messages['users.Action']}</ui:define>
                <a4j:commandLink actionListener="#{providerInformationSource.addValueToDsmlAttr(at)}"
                                 render="attributeTable" title="Add a value for this attribute"
                                 rendered="#{empty at.valuesForGui or (not currentRequest.isAttributeSingleValue(at.name))}">
                    <s:span styleClass="gzl-icon-plus"/>
                </a4j:commandLink>
                <a4j:commandLink id="DeleteImage" actionListener="#{currentRequest.removeAttributeFromAddRequest(at)}"
                                 title="#{messages['net.ihe.gazelle.hpd.RemoveFromList']}" render="attributeTable"
                                 rendered="#{not currentRequest.isDsmlAttributeRequired(at)}">
                    <s:span styleClass="gzl-icon-trash-o"/>
                </a4j:commandLink>
            </g:column>
        </rich:dataTable>
        <a4j:commandButton value="Add all optional attributes"
                           actionListener="#{currentRequest.addMayAttributeToAddRequest()}"
                           render="attributeTable"
                           styleClass="gzl-btn-blue"/>
        <a4j:commandButton value="Remove not valued attributes"
                           actionListener="#{currentRequest.removeEmptyAttributesFromAddRequest()}"
                           render="attributeTable"
                           styleClass="gzl-btn-orange"/>
    </s:div>
</ui:composition>
